#ifndef _FILEHELPERS_H_
#define _FILEHELPERS_H_

#include "StringBuffer.h"
#include "Buffer.h"

bool LoadTextfileToBufferA(const char* pFileName, CStringBufferA &buf);
bool LoadTextfileToBufferW(const char* pFileName, CStringBuffer &buf);
bool LoadTextfileToBufferA(const wchar_t* pFileName, CStringBufferA &buf);
bool LoadTextfileToBufferW(const wchar_t* pFileName, CStringBuffer &buf);
bool LoadFileToBuffer(const char* pFileName, CDynMemoryBuffer &buf);
bool WriteBufferToFile(const char* pFileName, CDynMemoryBuffer &buf);
bool WriteStringBufferToFile(const char* pFileName, CStringBufferA &buf);

#endif //!_FILEHELPERS_H_
