#ifndef _HELPERS_H_
#define _HELPERS_H_

template<class T> struct remove_ref { typedef T Type; };
template<class T> struct remove_ref<T&> { typedef T Type; };
template<class T> struct remove_ref<T&&> { typedef T Type; };

template<class T> typename remove_ref<T>::Type&&move(T &&t){ return (remove_ref<T>::Type &&)t; }

#endif //!_HELPERS_H_
