
#include "SR3IL.h"


const char* GetSRVDecl(UINT32 type){
	switch (type){
case SRVDecl_Position0: return "SRVDecl_Position0";
case SRVDecl_Position1: return "SRVDecl_Position1";
case SRVDecl_Position2: return "SRVDecl_Position2";
case SRVDecl_Position3: return "SRVDecl_Position3";
case SRVDecl_Position4: return "SRVDecl_Position4";
case SRVDecl_Position5: return "SRVDecl_Position5";
case SRVDecl_Position6: return "SRVDecl_Position6";
case SRVDecl_Position7: return "SRVDecl_Position7";
case SRVDecl_Texcoord0: return "SRVDecl_Texcoord0";
case SRVDecl_Texcoord1: return "SRVDecl_Texcoord1";
case SRVDecl_Texcoord2: return "SRVDecl_Texcoord2";
case SRVDecl_Texcoord3: return "SRVDecl_Texcoord3";
case SRVDecl_Texcoord4: return "SRVDecl_Texcoord4";
case SRVDecl_Texcoord5: return "SRVDecl_Texcoord5";
case SRVDecl_Texcoord6: return "SRVDecl_Texcoord6";
case SRVDecl_Texcoord7: return "SRVDecl_Texcoord7";
case SRVDecl_Normal0: return "SRVDecl_Normal0";
case SRVDecl_Normal1: return "SRVDecl_Normal1";
case SRVDecl_Normal2: return "SRVDecl_Normal2";
case SRVDecl_Normal3: return "SRVDecl_Normal3";
case SRVDecl_Normal4: return "SRVDecl_Normal4";
case SRVDecl_Normal5: return "SRVDecl_Normal5";
case SRVDecl_Normal6: return "SRVDecl_Normal6";
case SRVDecl_Normal7: return "SRVDecl_Normal7";
case SRVDecl_Tangent0: return "SRVDecl_Tangent0";
case SRVDecl_Tangent1: return "SRVDecl_Tangent1";
case SRVDecl_Tangent2: return "SRVDecl_Tangent2";
case SRVDecl_Tangent3: return "SRVDecl_Tangent3";
case SRVDecl_Tangent4: return "SRVDecl_Tangent4";
case SRVDecl_Tangent5: return "SRVDecl_Tangent5";
case SRVDecl_Tangent6: return "SRVDecl_Tangent6";
case SRVDecl_Tangent7: return "SRVDecl_Tangent7";
case SRVDecl_Binormal0: return "SRVDecl_Binormal0";
case SRVDecl_Binormal1: return "SRVDecl_Binormal1";
case SRVDecl_Binormal2: return "SRVDecl_Binormal2";
case SRVDecl_Binormal3: return "SRVDecl_Binormal3";
case SRVDecl_Binormal4: return "SRVDecl_Binormal4";
case SRVDecl_Binormal5: return "SRVDecl_Binormal5";
case SRVDecl_Binormal6: return "SRVDecl_Binormal6";
case SRVDecl_Binormal7: return "SRVDecl_Binormal7";
case SRVDecl_Color0: return "SRVDecl_Color0";
case SRVDecl_Color1: return "SRVDecl_Color1";
case SRVDecl_Color2: return "SRVDecl_Color2";
case SRVDecl_Color3: return "SRVDecl_Color3";
case SRVDecl_Color4: return "SRVDecl_Color4";
case SRVDecl_Color5: return "SRVDecl_Color5";
case SRVDecl_Color6: return "SRVDecl_Color6";
case SRVDecl_Color7: return "SRVDecl_Color7";
case SRVDecl_BlendIndices: return "SRVDecl_BlendIndices";
case SRVDecl_BlendWeight: return "SRVDecl_BlendWeight";
case SRVDecl_PSize: return "SRVDecl_PSize";
	}
};

const char* GetSRVType(UINT32 type){
	switch (type){
	case SRVType_Float1: return "SRVType_Float1";
	case SRVType_Float2: return "SRVType_Float2";
	case SRVType_Float3: return "SRVType_Float3";
	case SRVType_Float4: return "SRVType_Float4";
	case SRVType_Float16_2: return "SRVType_Float16_2";
	case SRVType_Float16_4: return "SRVType_Float16_4";
	case SRVType_UByte4: return "SRVType_UByte4";
	case SRVType_UByte4N: return "SRVType_UByte4N";
	case SRVType_Short2N: return "SRVType_Short2N";
	case SRVType_Short2N_A: return "SRVType_Short2N_A";
	case SRVType_Short2: return "SRVType_Short2";
	case SRVType_Short2_A: return "SRVType_Short2_A";
	case SRVType_UByte4N_A: return "SRVType_UByte4N_A";
	case SRVType_UByte4N_B: return "SRVType_UByte4N_B";
	case SRVType_D3DCOLOR: return "SRVType_D3DCOLOR";
	case SRVType_Short4: return "SRVType_Short4";
	case SRVType_UByte4_A: return "SRVType_UByte4_A";
	}
};

SInputLayoutElement g_LayoutElements_0[10] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_0 = { g_LayoutElements_0, 10 };
SInputLayoutElement g_LayoutElements_28[11] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_28 = { g_LayoutElements_28, 11 };
SInputLayoutElement g_LayoutElements_29[12] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_29 = { g_LayoutElements_29, 12 };
SInputLayoutElement g_LayoutElements_30[13] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_30 = { g_LayoutElements_30, 13 };
SInputLayoutElement g_LayoutElements_31[14] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_31 = { g_LayoutElements_31, 14 };
SInputLayoutElement g_LayoutElements_1[11] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_1 = { g_LayoutElements_1, 11 };
SInputLayoutElement g_LayoutElements_32[12] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_32 = { g_LayoutElements_32, 12 };
SInputLayoutElement g_LayoutElements_33[13] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_33 = { g_LayoutElements_33, 13 };
SInputLayoutElement g_LayoutElements_34[14] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_34 = { g_LayoutElements_34, 14 };
SInputLayoutElement g_LayoutElements_35[15] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 36, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_35 = { g_LayoutElements_35, 15 };
SInputLayoutElement g_LayoutElements_100[11] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_100 = { g_LayoutElements_100, 11 };
SInputLayoutElement g_LayoutElements_102[12] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_102 = { g_LayoutElements_102, 12 };
SInputLayoutElement g_LayoutElements_103[13] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_103 = { g_LayoutElements_103, 13 };
SInputLayoutElement g_LayoutElements_104[14] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_104 = { g_LayoutElements_104, 14 };
SInputLayoutElement g_LayoutElements_105[15] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_105 = { g_LayoutElements_105, 15 };
SInputLayoutElement g_LayoutElements_2[11] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_2 = { g_LayoutElements_2, 11 };
SInputLayoutElement g_LayoutElements_36[12] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_36 = { g_LayoutElements_36, 12 };
SInputLayoutElement g_LayoutElements_37[13] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_37 = { g_LayoutElements_37, 13 };
SInputLayoutElement g_LayoutElements_38[14] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_38 = { g_LayoutElements_38, 14 };
SInputLayoutElement g_LayoutElements_39[15] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_39 = { g_LayoutElements_39, 15 };
SInputLayoutElement g_LayoutElements_3[13] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_3 = { g_LayoutElements_3, 13 };
SInputLayoutElement g_LayoutElements_40[14] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_40 = { g_LayoutElements_40, 14 };
SInputLayoutElement g_LayoutElements_41[15] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_41 = { g_LayoutElements_41, 15 };
SInputLayoutElement g_LayoutElements_42[16] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 36, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_42 = { g_LayoutElements_42, 16 };
SInputLayoutElement g_LayoutElements_43[17] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 36, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 40, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_43 = { g_LayoutElements_43, 17 };
SInputLayoutElement g_LayoutElements_101[12] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_101 = { g_LayoutElements_101, 12 };
SInputLayoutElement g_LayoutElements_106[13] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_106 = { g_LayoutElements_106, 13 };
SInputLayoutElement g_LayoutElements_107[14] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_107 = { g_LayoutElements_107, 14 };
SInputLayoutElement g_LayoutElements_108[15] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_108 = { g_LayoutElements_108, 15 };
SInputLayoutElement g_LayoutElements_109[16] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 36, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_109 = { g_LayoutElements_109, 16 };
SInputLayoutElement g_LayoutElements_4[6] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_4 = { g_LayoutElements_4, 6 };
SInputLayoutElement g_LayoutElements_44[7] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_44 = { g_LayoutElements_44, 7 };
SInputLayoutElement g_LayoutElements_45[8] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_45 = { g_LayoutElements_45, 8 };
SInputLayoutElement g_LayoutElements_46[9] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_46 = { g_LayoutElements_46, 9 };
SInputLayoutElement g_LayoutElements_47[10] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_47 = { g_LayoutElements_47, 10 };
SInputLayoutElement g_LayoutElements_5[4] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
};
SInputLayout g_Layout_5 = { g_LayoutElements_5, 4 };
SInputLayoutElement g_LayoutElements_6[4] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
};
SInputLayout g_Layout_6 = { g_LayoutElements_6, 4 };
SInputLayoutElement g_LayoutElements_7[4] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 5, 0, 0, 0, 1 },
};
SInputLayout g_Layout_7 = { g_LayoutElements_7, 4 };
SInputLayoutElement g_LayoutElements_8[2] = {
	{ SRVDecl_Position0, SRVType_Short2, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
};
SInputLayout g_Layout_8 = { g_LayoutElements_8, 2 };
SInputLayoutElement g_LayoutElements_9[1] = {
	{ SRVDecl_Position0, SRVType_Short2_A, 0, 0, 0, 0, 0 },
};
SInputLayout g_Layout_9 = { g_LayoutElements_9, 1 };
SInputLayoutElement g_LayoutElements_10[9] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N, 0, 12, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_10 = { g_LayoutElements_10, 9 };
SInputLayoutElement g_LayoutElements_11[7] = {
	{ SRVDecl_Position0, SRVType_Float16_4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Float16_4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Color1, SRVType_UByte4N, 0, 24, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 32, 0, 0, 0 },
};
SInputLayout g_Layout_11 = { g_LayoutElements_11, 7 };
SInputLayoutElement g_LayoutElements_12[7] = {
	{ SRVDecl_Position0, SRVType_Float16_4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Float16_4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Color1, SRVType_UByte4N, 0, 24, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 32, 0, 0, 0 },
};
SInputLayout g_Layout_12 = { g_LayoutElements_12, 7 };
SInputLayoutElement g_LayoutElements_13[7] = {
	{ SRVDecl_Position0, SRVType_Float16_4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Float16_4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Color1, SRVType_UByte4N, 0, 24, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 32, 0, 0, 0 },
};
SInputLayout g_Layout_13 = { g_LayoutElements_13, 7 };
SInputLayoutElement g_LayoutElements_14[10] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_14 = { g_LayoutElements_14, 10 };
SInputLayoutElement g_LayoutElements_48[11] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_48 = { g_LayoutElements_48, 11 };
SInputLayoutElement g_LayoutElements_49[12] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_49 = { g_LayoutElements_49, 12 };
SInputLayoutElement g_LayoutElements_50[13] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_50 = { g_LayoutElements_50, 13 };
SInputLayoutElement g_LayoutElements_51[14] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_51 = { g_LayoutElements_51, 14 };
SInputLayoutElement g_LayoutElements_15[11] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_15 = { g_LayoutElements_15, 11 };
SInputLayoutElement g_LayoutElements_52[12] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_52 = { g_LayoutElements_52, 12 };
SInputLayoutElement g_LayoutElements_53[13] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_53 = { g_LayoutElements_53, 13 };
SInputLayoutElement g_LayoutElements_54[14] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_54 = { g_LayoutElements_54, 14 };
SInputLayoutElement g_LayoutElements_55[15] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_55 = { g_LayoutElements_55, 15 };
SInputLayoutElement g_LayoutElements_16[11] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_16 = { g_LayoutElements_16, 11 };
SInputLayoutElement g_LayoutElements_56[12] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_56 = { g_LayoutElements_56, 12 };
SInputLayoutElement g_LayoutElements_57[13] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_57 = { g_LayoutElements_57, 13 };
SInputLayoutElement g_LayoutElements_58[14] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_58 = { g_LayoutElements_58, 14 };
SInputLayoutElement g_LayoutElements_59[15] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_59 = { g_LayoutElements_59, 15 };
SInputLayoutElement g_LayoutElements_17[13] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_17 = { g_LayoutElements_17, 13 };
SInputLayoutElement g_LayoutElements_60[14] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_60 = { g_LayoutElements_60, 14 };
SInputLayoutElement g_LayoutElements_61[15] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_61 = { g_LayoutElements_61, 15 };
SInputLayoutElement g_LayoutElements_62[16] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_62 = { g_LayoutElements_62, 16 };
SInputLayoutElement g_LayoutElements_63[17] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 36, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_63 = { g_LayoutElements_63, 17 };
SInputLayoutElement g_LayoutElements_18[6] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_18 = { g_LayoutElements_18, 6 };
SInputLayoutElement g_LayoutElements_64[7] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_64 = { g_LayoutElements_64, 7 };
SInputLayoutElement g_LayoutElements_65[8] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_65 = { g_LayoutElements_65, 8 };
SInputLayoutElement g_LayoutElements_66[9] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_66 = { g_LayoutElements_66, 9 };
SInputLayoutElement g_LayoutElements_67[10] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_67 = { g_LayoutElements_67, 10 };
SInputLayoutElement g_LayoutElements_19[10] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_19 = { g_LayoutElements_19, 10 };
SInputLayoutElement g_LayoutElements_68[11] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_68 = { g_LayoutElements_68, 11 };
SInputLayoutElement g_LayoutElements_69[12] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_69 = { g_LayoutElements_69, 12 };
SInputLayoutElement g_LayoutElements_70[13] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_70 = { g_LayoutElements_70, 13 };
SInputLayoutElement g_LayoutElements_71[14] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_71 = { g_LayoutElements_71, 14 };
SInputLayoutElement g_LayoutElements_20[11] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_20 = { g_LayoutElements_20, 11 };
SInputLayoutElement g_LayoutElements_72[12] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_72 = { g_LayoutElements_72, 12 };
SInputLayoutElement g_LayoutElements_73[13] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_73 = { g_LayoutElements_73, 13 };
SInputLayoutElement g_LayoutElements_74[14] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_74 = { g_LayoutElements_74, 14 };
SInputLayoutElement g_LayoutElements_75[15] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_75 = { g_LayoutElements_75, 15 };
SInputLayoutElement g_LayoutElements_21[11] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_21 = { g_LayoutElements_21, 11 };
SInputLayoutElement g_LayoutElements_76[12] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_76 = { g_LayoutElements_76, 12 };
SInputLayoutElement g_LayoutElements_77[13] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_77 = { g_LayoutElements_77, 13 };
SInputLayoutElement g_LayoutElements_78[14] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_78 = { g_LayoutElements_78, 14 };
SInputLayoutElement g_LayoutElements_79[15] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_79 = { g_LayoutElements_79, 15 };
SInputLayoutElement g_LayoutElements_22[13] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_22 = { g_LayoutElements_22, 13 };
SInputLayoutElement g_LayoutElements_80[14] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_80 = { g_LayoutElements_80, 14 };
SInputLayoutElement g_LayoutElements_81[15] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_81 = { g_LayoutElements_81, 15 };
SInputLayoutElement g_LayoutElements_82[16] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_82 = { g_LayoutElements_82, 16 };
SInputLayoutElement g_LayoutElements_83[17] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Tangent0, SRVType_UByte4N_B, 0, 8, 0, 0, 0 },
	{ SRVDecl_BlendWeight, SRVType_UByte4, 0, 12, 0, 0, 0 },
	{ SRVDecl_BlendIndices, SRVType_UByte4, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position1, SRVType_Short2_A, 2, 0, 0, 0, 0 },
	{ SRVDecl_Normal1, SRVType_UByte4N_A, 2, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_UByte4N, 3, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_83 = { g_LayoutElements_83, 17 };
SInputLayoutElement g_LayoutElements_23[6] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_23 = { g_LayoutElements_23, 6 };
SInputLayoutElement g_LayoutElements_84[7] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 4, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_84 = { g_LayoutElements_84, 7 };
SInputLayoutElement g_LayoutElements_85[8] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 4, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_85 = { g_LayoutElements_85, 8 };
SInputLayoutElement g_LayoutElements_86[9] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 4, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_86 = { g_LayoutElements_86, 9 };
SInputLayoutElement g_LayoutElements_87[10] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 4, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_87 = { g_LayoutElements_87, 10 };
SInputLayoutElement g_LayoutElements_24[8] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_24 = { g_LayoutElements_24, 8 };
SInputLayoutElement g_LayoutElements_88[9] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_88 = { g_LayoutElements_88, 9 };
SInputLayoutElement g_LayoutElements_89[10] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_89 = { g_LayoutElements_89, 10 };
SInputLayoutElement g_LayoutElements_90[11] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_90 = { g_LayoutElements_90, 11 };
SInputLayoutElement g_LayoutElements_91[12] = {
	{ SRVDecl_Position0, SRVType_Float3, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 12, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 32, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_91 = { g_LayoutElements_91, 12 };
SInputLayoutElement g_LayoutElements_25[8] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_25 = { g_LayoutElements_25, 8 };
SInputLayoutElement g_LayoutElements_92[9] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_92 = { g_LayoutElements_92, 9 };
SInputLayoutElement g_LayoutElements_93[10] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_93 = { g_LayoutElements_93, 10 };
SInputLayoutElement g_LayoutElements_94[11] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_94 = { g_LayoutElements_94, 11 };
SInputLayoutElement g_LayoutElements_95[12] = {
	{ SRVDecl_Position0, SRVType_Short4, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 8, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 28, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_95 = { g_LayoutElements_95, 12 };
SInputLayoutElement g_LayoutElements_26[8] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 8, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_26 = { g_LayoutElements_26, 8 };
SInputLayoutElement g_LayoutElements_96[9] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_96 = { g_LayoutElements_96, 9 };
SInputLayoutElement g_LayoutElements_97[10] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_97 = { g_LayoutElements_97, 10 };
SInputLayoutElement g_LayoutElements_98[11] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_98 = { g_LayoutElements_98, 11 };
SInputLayoutElement g_LayoutElements_99[12] = {
	{ SRVDecl_Position0, SRVType_UByte4_A, 0, 0, 0, 0, 0 },
	{ SRVDecl_Normal0, SRVType_UByte4N_A, 0, 4, 0, 0, 0 },
	{ SRVDecl_Color0, SRVType_D3DCOLOR, 0, 8, 0, 0, 0 },
	{ SRVDecl_Texcoord0, SRVType_Short2, 0, 12, 0, 0, 0 },
	{ SRVDecl_Texcoord1, SRVType_Short2, 0, 16, 0, 0, 0 },
	{ SRVDecl_Texcoord2, SRVType_Short2, 0, 20, 0, 0, 0 },
	{ SRVDecl_Texcoord3, SRVType_Short2, 0, 24, 0, 0, 0 },
	{ SRVDecl_Position2, SRVType_Float4, 4, 0, 0, 0, 1 },
	{ SRVDecl_Position3, SRVType_Float4, 4, 16, 0, 0, 1 },
	{ SRVDecl_Position4, SRVType_Float4, 4, 32, 0, 0, 1 },
	{ SRVDecl_Color1, SRVType_D3DCOLOR, 4, 48, 0, 0, 1 },
	{ SRVDecl_Color2, SRVType_D3DCOLOR, 4, 52, 0, 0, 1 },
};
SInputLayout g_Layout_99 = { g_LayoutElements_99, 12 };
SInputLayout*	g_InputLayouts[110] = {
	&g_Layout_0,
	&g_Layout_1,
	&g_Layout_2,
	&g_Layout_3,
	&g_Layout_4,
	&g_Layout_5,
	&g_Layout_6,
	&g_Layout_7,
	&g_Layout_8,
	&g_Layout_9,
	&g_Layout_10,
	&g_Layout_11,
	&g_Layout_12,
	&g_Layout_13,
	&g_Layout_14,
	&g_Layout_15,
	&g_Layout_16,
	&g_Layout_17,
	&g_Layout_18,
	&g_Layout_19,
	&g_Layout_20,
	&g_Layout_21,
	&g_Layout_22,
	&g_Layout_23,
	&g_Layout_24,
	&g_Layout_25,
	&g_Layout_26,
	NULL,
	&g_Layout_28,
	&g_Layout_29,
	&g_Layout_30,
	&g_Layout_31,
	&g_Layout_32,
	&g_Layout_33,
	&g_Layout_34,
	&g_Layout_35,
	&g_Layout_36,
	&g_Layout_37,
	&g_Layout_38,
	&g_Layout_39,
	&g_Layout_40,
	&g_Layout_41,
	&g_Layout_42,
	&g_Layout_43,
	&g_Layout_44,
	&g_Layout_45,
	&g_Layout_46,
	&g_Layout_47,
	&g_Layout_48,
	&g_Layout_49,
	&g_Layout_50,
	&g_Layout_51,
	&g_Layout_52,
	&g_Layout_53,
	&g_Layout_54,
	&g_Layout_55,
	&g_Layout_56,
	&g_Layout_57,
	&g_Layout_58,
	&g_Layout_59,
	&g_Layout_60,
	&g_Layout_61,
	&g_Layout_62,
	&g_Layout_63,
	&g_Layout_64,
	&g_Layout_65,
	&g_Layout_66,
	&g_Layout_67,
	&g_Layout_68,
	&g_Layout_69,
	&g_Layout_70,
	&g_Layout_71,
	&g_Layout_72,
	&g_Layout_73,
	&g_Layout_74,
	&g_Layout_75,
	&g_Layout_76,
	&g_Layout_77,
	&g_Layout_78,
	&g_Layout_79,
	&g_Layout_80,
	&g_Layout_81,
	&g_Layout_82,
	&g_Layout_83,
	&g_Layout_84,
	&g_Layout_85,
	&g_Layout_86,
	&g_Layout_87,
	&g_Layout_88,
	&g_Layout_89,
	&g_Layout_90,
	&g_Layout_91,
	&g_Layout_92,
	&g_Layout_93,
	&g_Layout_94,
	&g_Layout_95,
	&g_Layout_96,
	&g_Layout_97,
	&g_Layout_98,
	&g_Layout_99,
	&g_Layout_100,
	&g_Layout_101,
	&g_Layout_102,
	&g_Layout_103,
	&g_Layout_104,
	&g_Layout_105,
	&g_Layout_106,
	&g_Layout_107,
	&g_Layout_108,
	&g_Layout_109,
};



UINT32 g_TypeSizes[SRVType_Last] = {
	sizeof(float), //SRVType_Float1
	sizeof(float)*2, //SRVType_Float2
	sizeof(float)*3, //SRVType_Float3
	sizeof(float)*4, //SRVType_Float4
	sizeof(UINT16)*2, //SRVType_Float16_2
	sizeof(UINT16)*4, //SRVType_Float16_4
	sizeof(UINT8)*4, //SRVType_UByte4
	sizeof(UINT8)*4, //SRVType_UByte4N
	sizeof(UINT16)*2, //SRVType_Short2N
	sizeof(UINT16)*2, //SRVType_Short2N_A
	sizeof(UINT16)*2, //SRVType_Short2
	sizeof(UINT16)*2, //SRVType_Short2_A
	sizeof(UINT8)*4, //SRVType_UByte4N_A
	sizeof(UINT8)*4, //SRVType_UByte4N_B
	sizeof(DWORD), //SRVType_D3DCOLOR
	sizeof(UINT16)*4, //SRVType_Short4
	sizeof(UINT8)*4, //SRVType_UByte4_A
};

UINT32 g_TypeMap[SRVType_Last] = {
	D3DDECLTYPE_FLOAT1, //SRVType_Float1
	D3DDECLTYPE_FLOAT2, //SRVType_Float2
	D3DDECLTYPE_FLOAT3, //SRVType_Float3
	D3DDECLTYPE_FLOAT4, //SRVType_Float4
	D3DDECLTYPE_FLOAT16_2, //SRVType_Float16_2
	D3DDECLTYPE_FLOAT16_4, //SRVType_Float16_4
	D3DDECLTYPE_UBYTE4, //SRVType_UByte4
	D3DDECLTYPE_UBYTE4N, //SRVType_UByte4N
	D3DDECLTYPE_SHORT2N, //SRVType_Short2N
	D3DDECLTYPE_SHORT2N, //SRVType_Short2N_A
	D3DDECLTYPE_SHORT2, //SRVType_Short2
	D3DDECLTYPE_SHORT2, //SRVType_Short2_A
	D3DDECLTYPE_UBYTE4N, //SRVType_UByte4N_A
	D3DDECLTYPE_UBYTE4N, //SRVType_UByte4N_B
	D3DDECLTYPE_D3DCOLOR, //SRVType_D3DCOLOR
	D3DDECLTYPE_SHORT4, //SRVType_Short4
	D3DDECLTYPE_UBYTE4, //SRVType_UByte4_A
};

UINT32 g_UsageMap[SRVDecl_Last] = {
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_POSITION,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_TEXCOORD,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_NORMAL,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_TANGENT,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_BINORMAL,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_COLOR,
	D3DDECLUSAGE_BLENDINDICES,
	D3DDECLUSAGE_BLENDWEIGHT,
	D3DDECLUSAGE_PSIZE,
};


UINT32 g_UsageIndexMap[SRVDecl_Last] = {
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	0,
	0,
	0,
};
SInputLayout* GetIL(UINT32 ID){
	if (ID >= sizeof(g_InputLayouts)/sizeof(SInputLayout*))
		return NULL;
	return g_InputLayouts[ID];
}


SInputValue &TV(SInputValue &val, double x){
	val.x = (float)x;
	val.ix = (int)x;
	val.n = 1;
	return val;
}

SInputValue &TV(SInputValue &val, double x, double y){
	val.x = (float)x;
	val.ix = (int)x;
	val.y = (float)y;
	val.iy = (int)y;
	val.n = 2;
	return val;
}

SInputValue &TV(SInputValue &val, double x, double y, double z){
	val.x = (float)x;
	val.ix = (int)x;
	val.y = (float)y;
	val.iy = (int)y;
	val.z = (float)z;
	val.iz = (int)z;
	val.n = 3;
	return val;
}

SInputValue &TV(SInputValue &val, double x, double y, double z, double w){
	val.x = (float)x;
	val.ix = (int)x;
	val.y = (float)y;
	val.iy = (int)y;
	val.z = (float)z;
	val.iz = (int)z;
	val.w = (float)w;
	val.iw = (int)w;
	val.n = 4;
	return val;
}
/*
UINT32 g_TypeMap[SRVType_Last] = {
	D3DDECLTYPE_FLOAT1, //SRVType_Float1
	D3DDECLTYPE_FLOAT2, //SRVType_Float2
	D3DDECLTYPE_FLOAT3, //SRVType_Float3
	D3DDECLTYPE_FLOAT4, //SRVType_Float4
	D3DDECLTYPE_FLOAT16_2, //SRVType_Float16_2
	D3DDECLTYPE_FLOAT16_4, //SRVType_Float16_4
	D3DDECLTYPE_UBYTE4, //SRVType_UByte4
	D3DDECLTYPE_UBYTE4N, //SRVType_UByte4N
	D3DDECLTYPE_SHORT2N, //SRVType_Short2N
	D3DDECLTYPE_SHORT2N, //SRVType_Short2N_A
	D3DDECLTYPE_SHORT2, //SRVType_Short2
	D3DDECLTYPE_SHORT2, //SRVType_Short2_A
	D3DDECLTYPE_SHORT4N, //SRVType_UByte4N_A
	D3DDECLTYPE_UBYTE4N, //SRVType_UByte4N_B
	D3DDECLTYPE_D3DCOLOR, //SRVType_D3DCOLOR
	D3DDECLTYPE_SHORT4, //SRVType_Short4
	D3DDECLTYPE_UBYTE4, //SRVType_UByte4_A
};
*/


class CFloat16Convert{
protected:
	static UINT32	s_MantissaTable[2048];
	static UINT32	s_ExponentTable[64];
	static UINT32	s_OffsetTable[64];
	UINT32 ConvertMantissa(UINT32 i){
		UINT32 m = i << 13;
		UINT32 e = 0;
		for (;!(m&0x00800000);){
			e-=0x00800000;
			m <<= 1;
		}
		m&=~0x00800000;
		e+=0x38800000;
		return m | e;
	}
	CFloat16Convert(){
		UINT32 i;
		s_MantissaTable[0] = 0;
		for (i = 1; i <= 1023; i++)
			s_MantissaTable[i] = ConvertMantissa(i);
		for (i = 1024; i <= 2047; i++)
			s_MantissaTable[i] = 0x38000000 + ((i-1024)<<13);

		s_ExponentTable[0] = 0;
		s_ExponentTable[32]= 0x80000000;
		for (i = 1; i <= 30; i++)
			s_ExponentTable[i] = i<<23;
		for (i = 33; i <= 62; i++)
			s_ExponentTable[i] = 0x80000000 + ((i-32)<<23);
		s_ExponentTable[31]= 0x47800000;
		s_ExponentTable[63]= 0xC7800000;
		s_OffsetTable[0] = 0;
		for (i = 1; i <= 63; i++)
			s_OffsetTable[i] = 1024;
		s_OffsetTable[32]= 0;
	}
	static CFloat16Convert	s_Instance;
public:
	static float F16ToF32(UINT16 Value){
		union {
			float f;
			UINT32 u;
		};
		u = s_MantissaTable[s_OffsetTable[Value>>10]+(Value&0x3ff)]+s_ExponentTable[Value>>10];
		return f;
	}
};


CFloat16Convert	CFloat16Convert::s_Instance;
UINT32	CFloat16Convert::s_MantissaTable[2048];
UINT32	CFloat16Convert::s_ExponentTable[64];
UINT32	CFloat16Convert::s_OffsetTable[64];

SInputValue &ToValue(SInputValue &val, const void* p, SInputLayoutElement* pElement){
	p = ((UINT8*)p)+pElement->Offset;
	switch (g_TypeMap[pElement->Type]){
	case D3DDECLTYPE_FLOAT1:
		return TV(val, ((float*)p)[0]);
	case D3DDECLTYPE_FLOAT2:
		return TV(val, ((float*)p)[0], ((float*)p)[1]);
	case D3DDECLTYPE_FLOAT3:
		return TV(val, ((float*)p)[0], ((float*)p)[1], ((float*)p)[2]);
	case D3DDECLTYPE_FLOAT4:
		return TV(val, ((float*)p)[0], ((float*)p)[1], ((float*)p)[2], ((float*)p)[3]);
	case D3DDECLTYPE_UBYTE4:
		return TV(val, ((UINT8*)p)[0], ((UINT8*)p)[1], ((UINT8*)p)[2], ((UINT8*)p)[3]);
	case D3DDECLTYPE_D3DCOLOR:
	case D3DDECLTYPE_UBYTE4N:
		return TV(val, ((UINT8*)p)[0]*(1.0/255.0), ((UINT8*)p)[1]*(1.0/255.0), ((UINT8*)p)[2]*(1.0/255.0), ((UINT8*)p)[3]*(1.0/255.0));
	case D3DDECLTYPE_SHORT2:
		return TV(val, ((INT16*)p)[0], ((INT16*)p)[1]);
	case D3DDECLTYPE_SHORT2N:
		return TV(val, ((INT16*)p)[0]*(1.0/SHRT_MAX), ((INT16*)p)[1]*(1.0/SHRT_MAX));
	case D3DDECLTYPE_SHORT4:
		return TV(val, ((INT16*)p)[0], ((INT16*)p)[1], ((INT16*)p)[2], ((INT16*)p)[3]);
	case D3DDECLTYPE_SHORT4N:
		return TV(val, ((INT16*)p)[0]*(1.0/SHRT_MAX), ((INT16*)p)[1]*(1.0/SHRT_MAX), ((INT16*)p)[2]*(1.0/SHRT_MAX), ((INT16*)p)[3]*(1.0/SHRT_MAX));
	case D3DDECLTYPE_FLOAT16_2:
		return TV(val, CFloat16Convert::F16ToF32(((UINT16*)p)[0]), CFloat16Convert::F16ToF32(((UINT16*)p)[1]));
	case D3DDECLTYPE_FLOAT16_4:
		return TV(val, CFloat16Convert::F16ToF32(((UINT16*)p)[0]), CFloat16Convert::F16ToF32(((UINT16*)p)[1]), CFloat16Convert::F16ToF32(((UINT16*)p)[2]), CFloat16Convert::F16ToF32(((UINT16*)p)[3]));
	}
	val.n = 0;
	return val;
}

SInputLayoutElement* GetElement(SInputLayout *pIL, UINT32 usage){
	UINT32 i;
	if (!pIL || !pIL->Elements || usage >= SRVDecl_Last)
		return NULL;
	for (i = 0; i < pIL->Count; i++){
		if (pIL->Elements[i].Usage == usage)
			return pIL->Elements+i;
	}
	return NULL;

}

SInputLayoutElement* GetElement(SInputLayout *pIL, UINT32 usage, UINT32 usageindex){
	UINT32 i;
	if (!pIL || !pIL->Elements)
		return NULL;
	for (i = 0; i < pIL->Count; i++){
		if (g_UsageMap[pIL->Elements[i].Usage] == usage && g_UsageIndexMap[pIL->Elements[i].Usage] == usageindex)
			return pIL->Elements+i;
	}
	return NULL;

}