#ifndef _BASE64_H_
#define _BASE64_H_

enum {
	Base64Encode_BufferTooSmall = -1,
	Base64Encode_InvalidPointer = -2,
	Base64Encode_InvalidLen = -3,
	Base64Decode_BufferTooSmall = -1,
	Base64Decode_InvalidCharacter = -2,
	Base64Decode_InvalidPointer = -3,
	Base64Decode_InvalidLen = -4,
};

inline int Base64EncodeLen(int _srclen){
	return (_srclen+2)/3*4;
}

inline int Base64DecodeLen(int _srclen){
	return _srclen/4*3;
}

int Base64Encode(const void* _src, int _srclen, void* _dst, int _dstlen);
int Base64Decode(const void* _src, int _srclen, void* _dst, int _dstlen);

#endif //!_BASE64_H_
