#ifndef _MEMORYMAPPEDFILE_H_
#define _MEMORYMAPPEDFILE_H_

#include <Windows.h>

class CMappedFile {
private:
	HANDLE	m_hFile;
	HANDLE	m_hMapping;
	PVOID	m_pMemory;
	DWORD	m_Size;
public:
	CMappedFile();
	~CMappedFile();
	bool Open(const char* pFilename);
	bool Create(const char* pName, int size);
	bool OpenExisting(const char* pName, bool r = true, bool w = true);
	void Close();
	PVOID GetMemory();
	DWORD GetSize();
};

#endif //!_MEMORYMAPPEDFILE_H_
