#ifndef _XMLFILTERS_H_
#define _XMLFILTERS_H_

#include "XML.h"
#include "String.h"

class CXMLFilterAttributeValue : public CXMLFilter {
private:
	IXML_SC	m_AttributeName;
	IXML_SC	m_AttributeValue;
public:
	CXMLFilterAttributeValue(IXML_CSTP pName, IXML_CSTP pValue) : m_AttributeName(pName), m_AttributeValue(pValue){}
	virtual bool Filter(IXMLData* pNode){
		IXMLData* pSubNode;
		pSubNode = pNode->GetNamedAttribute(m_AttributeName, NULL);
		if (!pSubNode)
			return false;
	}
};

#endif //!_XMLFILTERS_H_
